Name:           ocaml-camlp5
Version:        8.00.03
Release:        %mkrel 2
Summary:        Classical version of camlp4 OCaml preprocessor
Group:          Development/OCaml
License:        BSD
URL:            https://camlp5.github.io/
Source0:        https://github.com/camlp5/camlp5/archive/rel%{version}.tar.gz

# Kill -warn-error A
Patch0:         camlp5-8.00-kill-warn-error.patch

BuildRequires:  make
BuildRequires:  ocaml >= 4.05
BuildRequires:  ocaml-ocamldoc
BuildRequires:  perl
BuildRequires:  ocaml-camlp-streams >= 5.0
BuildRequires:  ocaml-findlib

Provides:       camlp5 = %{version}-%{release}
Obsoletes:      camlp5 < %{version}-%{release}

%global __ocaml_requires_opts -i Asttypes -i Parsetree -i Pa_extend
%global __ocaml_provides_opts -i Dynlink -i Dynlinkaux -i Pa_extend

%description
Camlp5 is a preprocessor-pretty-printer of OCaml.

It is the continuation of the classical camlp4 with new features.

OCaml 3.10 and above have an official camlp4 which is incompatible
with classical (<= 3.09) versions.  You can find that in the
ocaml-camlp4 package.


%package        devel
Summary:        Development files for %{name}
Group:          Development/C
Requires:       %{name} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%autosetup -p1 -n camlp5-rel%{version}
find . -name .gitignore -delete

# Build with debug information
sed -i 's,WARNERR="",WARNERR="-g",' configure
sed -i 's,-linkall,& -g,g' top/Makefile
for fil in compile/compile.sh $(find . -name Makefile); do
  sed -i 's,\$[({]OCAMLN[})]c,& -g,;s,\$[({]OCAMLN[})]opt,& -g,;s,LINKFLAGS=,&-g ,' $fil
done


%build
# Upstream uses hand-written configure, grrrrrr.
./configure \
    --prefix %{_prefix} \
    --bindir %{_bindir} \
    --libdir %{_libdir}/ocaml \
    --mandir %{_mandir}
make

%install
mkdir -p %{buildroot}%{_libdir}/ocaml
# This is a hack because the make install rule is broken upstream.
# We move the file later.
mkdir -p {buildroo%t}%{_libdir}/ocaml/ocaml
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}
make install DESTDIR=$RPM_BUILD_ROOT
install -m 644 etc/META %{buildroot}%{_libdir}/ocaml/camlp5/
rm -f doc/htmlp/{*.sh,Makefile,html2*}


%files
%license LICENSE
%doc README.md
%{_bindir}/camlp5*
%{_bindir}/mkcamlp5*
%{_bindir}/ocpp5
%{_mandir}/man1/*.1*
%{_libdir}/ocaml/camlp5
%exclude %{_libdir}/ocaml/camlp5/*.a
%exclude %{_libdir}/ocaml/camlp5/*.cmxa
%exclude %{_libdir}/ocaml/camlp5/*.cmx
%exclude %{_libdir}/ocaml/camlp5/*.mli


%files devel
%doc CHANGES ICHANGES DEVEL UPGRADING doc/html
%{_libdir}/ocaml/camlp5/*.a
%{_libdir}/ocaml/camlp5/*.cmxa
%{_libdir}/ocaml/camlp5/*.cmx
%{_libdir}/ocaml/camlp5/*.mli


%changelog
* Fri Oct 07 2022 pterjan <pterjan> 8.00.03-2.mga9
+ Revision: 1895319
- Rebuild for new ocaml-camlp-streams

* Thu May 19 2022 pterjan <pterjan> 8.00.03-1.mga9
+ Revision: 1859144
- Update to 8.00.03 final
- Rebuild for OCaml 4.14

* Tue Mar 29 2022 umeabot <umeabot> 8.00.03-0.2.mga9
+ Revision: 1832102
- Mageia 9 Mass Rebuild

* Tue Oct 12 2021 tv <tv> 8.00.03-0.1.mga9
+ Revision: 1750702
- OCaml 4.13.1 build
- Move to pre-release of 8.00.03 (git commit f1ede8037e)
- Remove upstream patch.
- Remove %%opt macro as its not used.

* Wed Mar 03 2021 tv <tv> 8.00-2.mga9
+ Revision: 1696529
- New upstream version 8.00.
- Remove topfind.camlp5 - seems to have been removed from upstream.

* Fri Aug 21 2020 umeabot <umeabot> 7.11-2.mga8
+ Revision: 1617566
- Rebuild for new ocaml deps generator

* Tue Mar 17 2020 tv <tv> 7.11-1.mga8
+ Revision: 1557274
- 7.11

* Fri Feb 28 2020 umeabot <umeabot> 7.10-3.mga8
+ Revision: 1551135
- Rebuild for ocaml 4.10.0 final

* Wed Feb 19 2020 umeabot <umeabot> 7.10-2.mga8
+ Revision: 1543645
- Mageia 8 Mass Rebuild

* Wed Jan 22 2020 tv <tv> 7.10-1.mga8
+ Revision: 1482008
- new release + rebuild for ocaml-4.10

* Wed Mar 06 2019 daviddavid <daviddavid> 7.07-4.mga7
+ Revision: 1371994
- really obsoletes camlp5
- move binaries and manpages into main pkg

* Thu Nov 01 2018 tv <tv> 7.07-3.mga7
+ Revision: 1327297
- bump release so that it's greater than older camlp5

* Wed Oct 24 2018 tv <tv> 7.07-2.mga7
+ Revision: 1325013
- obsoletes camlp5
- imported package ocaml-camlp5

